------------------------------------------------------------
-- Skript Pow3r digital 2020-05
------------------------------------------------------------


-- Service Provider



-- Stored Procedure: Rumpf

create or replace procedure lib/proc (
                in inParms integer default 0
            )
        language sql
        reads sql data
        program type sub
        concurrent access resolution default
        dynamic result sets 1
        old savepoint level
        commit on return no

        set option extind = *yes

begin

    -- Variablen deklarieren
    
    declare SQLCode integer default 0;

    -- Ausnahme Behandlung 

    declare exit handler for SQLException, SQLWarning  begin
                                                               
                                                       end;

     -- Cursor deklaration bei Lesendem Zugriff 
   
    declare Daten insensitive cursor for
     select 
             F1, 
             F2
      from   ViewOrTablel
      where  (Q1 = Q2);
 
      open Daten;
      
     -- andere Datenzugriffe
     ---- insert, update, delete, execute, execute immediate...
    
     -- sonstige Prozedurale Anweisungen

end
;
stop;


-- Stored Procedure: insertCustomer

create or replace procedure epsscldta/insertCustomer (
                                                        in INFINR decimal(2),
                                                        in INNAM1 char(32),
                                                        in INNAM2 char(32),
                                                        in INNAM3 char(32),
                                                        in INSTR char(32),
                                                        in INLAND char(3),
                                                        in INPLZ  char(7),
                                                        in INORT char(25),
                                                        in INTEL char(20),
                                                        in INFAX char(20),
                                                        in INFTF char(20),
                                                        in INEML char(60),
                                                        in INBLZ char(40),
                                                        in INKTO char(15),
                                                        in ININTER  char(32)
                                                    )
        language sql
        modifies sql data
        program type sub
        concurrent access resolution default
        dynamic result sets 0
        old savepoint level
        commit on return no

        set option extind = *yes

begin

    declare SQLCode integer default 0;

    declare lclMessage varchar(133);
    declare lclMsgId char(7);
    declare lclCompoundMessage varchar(255);


    declare exit handler for SQLException, SQLWarning  begin
                                                             GET DIAGNOSTICS CONDITION 1 lclMessage = MESSAGE_TEXT,                                                              
                                                                                         lclMsgiD  = DB2_MESSAGE_ID;
                                                             SET lclCompoundMessage = lclMsgId || ':' || lclMessage;                                                                                                                                
                                                             SIGNAL SQLSTATE  '35Y01'   SET MESSAGE_TEXT = lclCompoundMessage; 
                                                       end;
          
    SET TRANSACTION ISOLATION LEVEL READ COMMITTED; -- commit = *cs

    insert into SVKLST00 (
                            KLFINR,
                            KLIDNR,
                            KLNAM1,
                            KLNAM2,
                            KLNAM3,
                            KLSTR,
                            KLLAND,
                            KLPLZ,
                            KLORT,
                            KLTEL,
                            KLFAX,
                            KLFTF,
                            KLEML,
                            KLBLZ,
                            KLKTO,
                            KLDATN,
                            KLUSRN,
                            KLDATC,
                            KLUSRC,
                            KLINTER                       
                         )
                values   (
                           INFINR,
                           (
                            select case 
                                   when max(KLIDNR) is null then 1
                                   else max(KLIDNR) + 1
                                   end             
                             from SVKLST00 where KLFINR = INFINR
                           ), 
                           INNAM1,
                           INNAM2,
                           INNAM3,
                           INSTR,
                           INLAND,
                           INPLZ,
                           INORT,
                           INTEL,
                           INFAX,
                           INFTF,
                           INEML,
                           INBLZ,
                           INKTO,
                           current_date,
                           current_user,
                           current_date,
                           current_user,
                           ININTER            
                         );

    if SQLCode = 0 then
       commit;
    else
       rollback;
       SIGNAL SQLSTATE  '35Y01'   SET MESSAGE_TEXT = 'Kunde nicht erfasst'; 
    end if;
    


   
end
;
stop;

-- Unit-Test: insertCustomer

call insertCustomer( 3, 
                    'EPOS GMBH', 
                    'DV-Consult &',
                    'Training',
                    'Weserstr. 81', 
                    'DE', 
                    '28779',
                    'Bremen', 
                    '0421/659980',
                    '0421/6599865',
                    '0171/123654711',
                    'info@eposgmbh.com',
                    'DE45123456789012345678',
                    '47114712',
                    'www.eposgmbh.com'
                    )
;
stop;

call insertCustomer( 3, 
                    'POW3R 1', 
                    'Digital',
                    'Education',
                    'Weserstr. 81', 
                    'DE', 
                    '28779',
                    'Bremen', 
                    '0421/659980',
                    '0421/6599865',
                    '0171/123654711',
                    'info@eposgmbh.com',
                    'DE45123456789012345678',
                    '47114712',
                    'www.pow3r.info'
                    )
;
stop;


select * from svklst00 where klfinr = 3;
stop;




-- Stored Procedure: updateCustomer
drop procedure updateCustomer;

create or replace procedure epsscldta/updateCustomer(
                                                        in INFINR decimal(2) default 0,
                                                        in INIDNR decimal(7) default 0,
                                                        in INNAM1 char(32) default ' ',
                                                        in INNAM2 char(32) default ' ',
                                                        in INNAM3 char(32) default ' ',
                                                        in INSTR char(32) default ' ',
                                                        in INLAND char(3) default ' ',
                                                        in INPLZ  char(7) default ' ',
                                                        in INORT char(25) default ' ',
                                                        in INTEL char(20) default ' ',
                                                        in INFAX char(20) default ' ',
                                                        in INFTF char(20) default ' ',
                                                        in INEML char(60) default ' ',
                                                        in INBLZ char(40) default ' ',
                                                        in INKTO char(15) default ' ',
                                                        in ININTER  char(32) default ' '
                                                    )
        language sql
        specific epsscldta/updcst
        modifies sql data
        program type sub
        concurrent access resolution default
        dynamic result sets 0
        old savepoint level
        commit on return no
         
        set option extind = *yes

begin

    declare SQLCode integer default 0;

    declare lclMessage varchar(133);
    declare lclMsgId char(7);
    declare lclCompoundMessage varchar(255);
    declare lclCommand char(128);

    declare LCLDATN date;
    declare LCLUSRN char(10);
    declare LCLDATC date;
    declare LCLUSRC char(10);


    declare LCLFINR_IND integer default 0;   -- muss
    declare LCLIDNR_IND integer default 0;   -- muss

    declare LCLNAM1_IND integer default 0;   -- muss
    declare LCLNAM2_IND integer default 0;
    declare LCLNAM3_IND integer default 0;
    declare LCLSTR_IND integer default 0;    -- muss
    declare LCLLAND_IND integer default 0;   -- muss
    declare LCLPLZ_IND  integer default 0;   -- muss
    declare LCLORT_IND integer default 0;    -- muss
    declare LCLTEL_IND integer default 0;
    declare LCLFAX_IND integer default 0;
    declare LCLFTF_IND integer default 0;
    declare LCLEML_IND integer default 0;
    declare LCLBLZ_IND integer default 0;
    declare LCLKTO_IND integer default 0;
    
    declare LCLDATN_IND integer default -7;
    declare LCLUSRN_IND integer default -7;
    declare LCLDATC_IND integer default 0;
    declare LCLUSRC_IND integer default 0;
    
    declare LCLINTER_IND  integer default 0;

    declare lclDoNotUpdate integer default -7;

    declare const_Char integer default 1;
    declare const_Decimal integer default 3;
    declare const_Integer integer default 4;
    declare const_Date integer default 9;



    declare lclSQL_Command CLOB (2M); 
    

    declare exit handler for SQLException, SQLWarning  begin
                                                             GET DIAGNOSTICS CONDITION 1 lclMessage = MESSAGE_TEXT,                                                              
                                                                                         lclMsgiD  = DB2_MESSAGE_ID;
                                                             SET lclCompoundMessage = lclMsgId || ':' || trim(lclMessage);                                                                                                                                
                                                             SIGNAL SQLSTATE  '35Y01'   SET MESSAGE_TEXT = lclCompoundMessage; 
                                                       end;

    SET TRANSACTION ISOLATION LEVEL READ COMMITTED; -- commit = *cs


    set lclSQL_Command = 'update SVKLST00 set (KLNAM1, KLNAM2, KLNAM3, KLSTR, KLLAND, KLPLZ, KLORT, KLTEL, KLFAX, KLFTF, KLEML, KLBLZ, KLKTO, KLDATN, KLUSRN, KLDATC, KLUSRC, KLINTER) = ' ||
                                             '(?,     ?,      ?,      ?,     ?,      ?,     ?,     ?,     ?,     ?,     ?,     ?,     ?,     ?,      ?,      ?,      ?,      ?) ' ||
                                             'where KLFINR = ? and KLIDNR = ?';        

          
    ALLOCATE SQL DESCRIPTOR 'DSCR1';

    PREPARE SQLSTMT FROM lclSQL_Command ;

    DESCRIBE INPUT SQLSTMT USING SQL DESCRIPTOR 'DSCR1';


    if INFINR = 0 or INIDNR = 0 then
      SIGNAL SQLSTATE  '35Y01' SET MESSAGE_TEXT = 'SP: updateCustomer:  Input Fehler.';
    else
   
      if INNAM1 = ' ' then
          set lclNAM1_IND = lclDoNotUpdate;
      end if;
      if INNAM2 = ' ' then
          set lclNAM2_IND = lclDoNotUpdate;
      end if;
      if INNAM3 = ' ' then
          set LCLNAM3_IND = lclDoNotUpdate;
      end if;      
      if INSTR = ' ' then
          set LCLSTR_IND = lclDoNotUpdate;
      end if;
      if INLAND = ' ' then
          set LCLLAND_IND = lclDoNotUpdate;
      end if;
      if INPLZ = ' ' then
          set LCLPLZ_IND = lclDoNotUpdate;
      end if;
      if INORT = ' ' then
          set LCLORT_IND = lclDoNotUpdate;
      end if;
      if INTEL = ' ' then
          set LCLTEL_IND = lclDoNotUpdate;
      end if;      
      if INFAX = ' ' then
          set lclFAX_IND = lclDoNotUpdate;
      end if;      
      if INFTF = ' ' then
          set lclFTF_IND = lclDoNotUpdate;
      end if;      
      if INEML = ' ' then
          set lclEML_IND = lclDoNotUpdate;
      end if;      
      if INBLZ = ' ' then
          set lclBLZ_IND = lclDoNotUpdate;
      end if;      
      if INKTO = ' ' then
          set lclKTO_IND = lclDoNotUpdate;
      end if;      
      if ININTER = ' ' then
          set lclINTER_IND = lclDoNotUpdate;
      end if;      

      set LCLDATN = current_date;
      set LCLUSRN = current_user;
      set LCLDATC = current_date;
      set LCLUSRC = current_user;
      
      SET SQL DESCRIPTOR 'DSCR1' VALUE 1  TYPE = const_Char, 
                                           DATA = INNAM1,
                                           INDICATOR = 0,
                                           Length=32;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 2  TYPE = const_Char, 
                                           DATA = INNAM2, 
                                           INDICATOR = lclNAM2_IND,
                                           Length=32;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 3  TYPE = const_Char, 
                                           DATA = INNAM3,
                                           INDICATOR = lclNAM3_IND,
                                           Length=32;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 4  TYPE = const_Char, 
                                           DATA = INSTR,
                                           INDICATOR = lclSTR_IND,
                                           Length=32;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 5  TYPE = const_Char, 
                                           DATA = INLAND, 
                                           INDICATOR = lclLAND_IND,
                                           Length=3;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 6  TYPE = const_Char, 
                                           DATA = INPLZ,
                                           INDICATOR = lclPLZ_IND,
                                           Length=7;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 7  TYPE = const_Char, 
                                           DATA = INORT,  
                                           INDICATOR = lclORT_IND,
                                           Length=25;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 8  TYPE = const_Char,
                                           DATA = INTEL,
                                           INDICATOR = lclTEL_IND,
                                           Length=20;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 9  TYPE = const_Char, 
                                           DATA = INFAX,  
                                           INDICATOR = lclFAX_IND,
                                           Length=20;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 10 TYPE = const_Char, 
                                           DATA = INFTF,
                                           INDICATOR = lclFTF_IND,
                                           Length=20;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 11 TYPE = const_Char, 
                                           DATA = INEML,
                                           INDICATOR = lclEML_IND,
                                           Length=60;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 12 TYPE = const_Char, 
                                           DATA = INBLZ,
                                           INDICATOR = lclBLZ_IND,
                                           Length=40;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 13 TYPE = const_Char, 
                                           DATA = INKTO,
                                           INDICATOR = lclKTO_IND,
                                           Length=15;
       
      SET SQL DESCRIPTOR 'DSCR1' VALUE 14 TYPE = const_Date, 
                                           DATA = LCLDATN ,  
                                           INDICATOR = lclDATN_IND,
                                           DATETIME_INTERVAL_CODE = 1,
                                           Length=10;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 15 TYPE = const_Char, 
                                           DATA = LCLUSRN ,  
                                           INDICATOR = lclUSRN_IND,
                                           Length=10;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 16 TYPE = const_Date, 
                                           DATA = LCLDATC ,  
                                           INDICATOR = lclDATC_IND,
                                           DATETIME_INTERVAL_CODE = 1,
                                           Length=10;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 17 TYPE = const_Char, 
                                           DATA = LCLUSRC ,  
                                           INDICATOR = lclUSRC_IND,
                                           Length=10;
       
      SET SQL DESCRIPTOR 'DSCR1' VALUE 18 TYPE = const_Char, 
                                           DATA = ININTER , 
                                           INDICATOR = lclINTER_IND,
                                           Length=60;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 19 TYPE = const_Decimal, 
                                           DATA = INFINR , 
                                           INDICATOR = lclFINR_IND,
                                           Length=2,
                                           PRECISION = 2, 
                                           SCALE = 0;
      SET SQL DESCRIPTOR 'DSCR1' VALUE 20 TYPE = const_Decimal, 
                                           DATA = INIDNR , 
                                           INDICATOR = lclIDNR_IND,
                                           Length=4,
                                           PRECISION = 7, 
                                           SCALE = 0;


      EXECUTE SQLSTMT USING SQL DESCRIPTOR 'DSCR1';
      if SQLCode = 0 then
         commit;
      else
         rollback;
      end if;
      
    end if;

end;
stop;

-- Unit-Test: deleteCustomer

call updateCustomer();

call updateCustomer(3, 9, innam3 => 'digital');

select * from svklst00 where klfinr = 3;
stop;


-- Stored Procedure: deleteCustomer

create or replace procedure epsscldta/deleteCustomer (
                                                        in INFINR decimal(2),
                                                        in INIDNR decimal(7)
                                                    )
        language sql
        modifies sql data
        program type sub
        concurrent access resolution default
        dynamic result sets 0
        old savepoint level
        commit on return no

        set option extind = *yes

begin

    declare SQLCode integer default 0;

    declare lclMessage varchar(133);
    declare lclMsgId char(7);
    declare lclCompoundMessage varchar(255);


    declare exit handler for SQLException, SQLWarning  begin
                                                             GET DIAGNOSTICS CONDITION 1 lclMessage = MESSAGE_TEXT,                                                              
                                                                                         lclMsgiD  = DB2_MESSAGE_ID;
                                                             SET lclCompoundMessage = lclMsgId || ':' || lclMessage;                                                                                                                                
                                                             SIGNAL SQLSTATE  '35Y01'   SET MESSAGE_TEXT = lclCompoundMessage; 
                                                       end;
          
   SET TRANSACTION ISOLATION LEVEL READ COMMITTED; -- commit = *cs

   delete from SVKLST00 where KLFINR = INFINR and KLIDNR = INIDNR; 
   if SQLCode = 0 then
       commit;
   else
       rollback;
   end if;

end;
stop;

-- Unit-Test: deleteCustomer

call deleteCustomer(3, 2);
select * from svklst00 where klfinr = 3;
stop;



-- Stored Procedure: getCustomers

drop procedure epsscldta/getCustomers;

create or replace procedure epsscldta/getCustomers (
                                                        in INFINR decimal(2, 0),                                                    
                                                        in INSEARCH varchar(100) default null                                                   
                                                   )
        language sql
        modifies sql data
        program type sub
        concurrent access resolution default
        dynamic result sets 1
        old savepoint level
        commit on return no

        set option extind = *yes

begin

    declare SQLCode integer default 0;
    declare SQLState char(5) default ' ';

    declare lclMessage varchar(133);
    declare lclMsgId char(7);
    declare lclCompoundMessage varchar(255) default 'Es wurden keine Daten gefunden';

    declare  Daten insensitive cursor for
             with kunden as(
                 select
                        digits(KLFINR) || digits(KLIDNR) || trim(KLNAM1) || trim(KLNAM2) || trim(KLNAM3) || trim(KLSTR) || 
                        trim(KLLAND) || trim(KLPLZ) || trim(KLORT) || trim(KLTEL) || trim(KLFAX) || trim(KLFTF) || trim(KLEML) ||
                        trim(KLBLZ) || trim(KLKTO) || char(KLDATN) || trim(KLUSRN) || char(KLDATC) || trim(KLUSRC) || trim(KLINTER) as SearchString,

                        KLFINR,
                        KLIDNR,
                        KLNAM1,
                        KLNAM2,
                        KLNAM3,
                        KLSTR,
                        KLLAND,
                        KLPLZ,
                        KLORT,
                        KLTEL,
                        KLFAX,
                        KLFTF,
                        KLEML,
                        KLBLZ,
                        KLKTO,
                        KLDATN,
                        KLUSRN,
                        KLDATC,
                        KLUSRC,
                        KLINTER
                  from SVKLST00  
             )
             
             select 
                        KLFINR,
                        KLIDNR,
                        KLNAM1,
                        KLNAM2,
                        KLNAM3,
                        KLSTR,
                        KLLAND,
                        KLPLZ,
                        KLORT,
                        KLTEL,
                        KLFAX,
                        KLFTF,
                        KLEML,
                        KLBLZ,
                        KLKTO,
                        KLDATN,
                        KLUSRN,
                        KLDATC,
                        KLUSRC,
                        KLINTER
             from Kunden where  (KLFINR = INFINR and upper(Searchstring) like upper('%'|| trim(INSEARCH) || '%')) or
                                (KLFINR = INFINR and INSEARCH is null)
             ;    




    open Daten;
    if SQLState = '0100C' then
       SIGNAL SQLSTATE  '35Y01'   SET MESSAGE_TEXT = lclCompoundMessage; 
    end if;
                             
end;
stop;

-- Unit-Test: getCustomers

call getCustomers(3);
call getCustomers(3, null);
call getCustomers(3, 'Pow3r');

stop;

-- Service Consumer


---- Service testen

-----------------------------------------------------------------------
---- Service SQL_getCustomersByCompany aufrufen und Ergebnis (JSON) parsen

values(SYSTOOLS.HTTPGETCLOB('http://172.16.111.23:10010/web/services/SQL_getCustomersByCompany/3/0',null));





select 
        * 
 from JSON_TABLE( SYSTOOLS.HTTPGETCLOB('http://172.16.111.23:10010/web/services/SQL_getCustomersByCompany/3/edu',null), 
                            '$.SQL_getCustomersByCompany_GetAll_R[*]' 
                            COLUMNS( 
                                             Firma integer PATH '$.KLFINR',
                                             Ident integer PATH '$.KLIDNR',
                                             Name01 varchar(32) PATH '$.KLNAM1', 
                                             Name02 varchar(32) PATH '$.KLNAM2',
                                             Name03 varchar(32) PATH '$.KLNAM3'
                                   )
        ) AS X
;


select 
        * 
 from JSON_TABLE( SYSTOOLS.HTTPGETCLOB('http://172.16.111.23:10010/web/services/SQL_getCustomersByCompany/1/0',null), 
                  'lax $'               
                   COLUMNS (
                            Fehler CHAR(3) PATH 'lax $.SQLStateInfo.SQLError',
                            Warnung CHAR(3) PATH 'lax $.SQLStateInfo.SQLWarnings',
                            NESTED PATH 
                            '$.SQL_getCustomersByCompany_GetAll_R[*]' 
                               COLUMNS( 
                                             Firma integer PATH '$.KLFINR',
                                             Ident integer PATH '$.KLIDNR',
                                             Name01 varchar(32) PATH '$.KLNAM1', 
                                             Name02 varchar(32) PATH '$.KLNAM2',
                                             Name03 varchar(32) PATH '$.KLNAM3',
                                             Strasse varchar(32) PATH '$.KLSTR',
                                             Land varchar(32) PATH '$.KLLAND',
                                             Plz varchar(32) PATH '$.KLPLZ',
                                             Ort varchar(32) PATH '$.KLORT',
                                             Telefon varchar(20) PATH '$.KLTEL',
                                             Fax varchar(20) PATH '$.KLFAX',
                                             Handy varchar(20) PATH '$.KLFTF',
                                             Email varchar(60) PATH '$.KLEML',
                                             BLZ varchar(40) PATH '$.KLBLZ',
                                             KontoNr varchar(20) PATH '$.KLKTO',
                                             DatumNeuerfassung date PATH '$.KLDATN',
                                             BenutzerErfassung varchar(10) PATH '$.KLUSRN',
                                             DatumAenderung date PATH '$.KLDATC',
                                             BenutzerAenderung varchar(32) PATH '$.KLUSRC',
                                             Internet varchar(255) PATH '$.KLINTER'
                                      )
                           )           
        ) AS X
;

select * from svklst00 where klfinr = 3

-----------------------------------------------------------------------
---- Service SQL_insertCustomer aufrufen und Ergebnis (JSON) parsen

values(httppostclob('http://172.16.111.23:10010/web/services/SQL_insertCustomer/',
              cast('<httpHeader><header name="Content-Type" value="application/json"/></httpHeader>' as clob(10k) ccsid 1208),
              cast ('{
                    	"INFINR": "3",
                    	"INNAM1": "Henry 2." ,
                    	"INNAM2": "Motzkus",
                    	"INNAM3": "",
                    	"INSTR":  "Betonstr. 1",
                    	"INLAND": "DE",
                    	"INPLZ":  "28779",
                    	"INORT": "Bremen",
                    	"INTEL": "049421123456",
                    	"INFAX": "0494211234576",
                    	"INFTF": "0491714211234586",
                    	"INEML": "motzkus@eposgmbh.com",
                    	"INBLZ": "E12345678901234567890",
                    	"INKTO": "12345678",
                    	"ININTER": "www.motzkus.de"
                    }' as clob(2g) ccsid 1208
                   )
            )
);


select 
        * 
 from JSON_TABLE( 
                    httppostclob('http://172.16.111.23:10010/web/services/SQL_insertCustomer/',
                                  cast('<httpHeader><header name="Content-Type" value="application/json"/></httpHeader>' as clob(10k) ccsid 1208),
                                  cast ('{
                                        	"INFINR": "3",
                                        	"INNAM1": "Henry 5." ,
                                        	"INNAM2": "Motzkus",
                                        	"INNAM3": "",
                                        	"INSTR":  "Betonstr. 1",
                                        	"INLAND": "DE",
                                        	"INPLZ":  "28779",
                                        	"INORT": "Bremen",
                                        	"INTEL": "049421123456",
                                        	"INFAX": "0494211234576",
                                        	"INFTF": "0491714211234586",
                                        	"INEML": "motzkus@eposgmbh.com",
                                        	"INBLZ": "E12345678901234567890",
                                        	"INKTO": "12345678",
                                        	"ININTER": "www.motzkus.de"
                                        }' as clob(2g) ccsid 1208
                                       )
                                ), 
                  'lax $'               
                   COLUMNS (
                            VerarbeiteteZeilen CHAR(3) PATH 'lax $.SQLStateInfo.rowsAffectedCounts',
                            Fehler CHAR(100) PATH 'lax $.SQLStateInfo.SQLError',
                            Warnung CHAR(100) PATH 'lax $.SQLStateInfo.SQLWarnings'
                            )
                 ) as ServiceCall
;                 

select * from svklst00 where klfinr = 3;


-----------------------------------------------------------------------
---- Service SQL_updateCustomer aufrufen und Ergebnis (JSON) parsen

values(httpputclob('http://172.16.111.23:10010/web/services/SQL_updateCustomer/',
              cast('<httpHeader><header name="Content-Type" value="application/json"/></httpHeader>' as clob(10k) ccsid 1208),
              cast ('{
                        	"INFINR": "3",
                        	"INIDNR": "7",
                        	"INNAM1": "Henry 4." ,
                        	"INNAM2": "",
                        	"INNAM3": "",
                        	"INSTR":  "",
                        	"INLAND": "",
                        	"INPLZ":  "",
                        	"INORT": "",
                        	"INTEL": "",
                        	"INFAX": "",
                        	"INFTF": "",
                        	"INEML": "",
                        	"INBLZ": "",
                        	"INKTO": "",
                        	"ININTER": ""
                     }' as clob(2g) ccsid 1208
                   )
            )
);

select 
        * 
 from JSON_TABLE( 
                    httpputclob('http://172.16.111.23:10010/web/services/SQL_updateCustomer/',
                                  cast('<httpHeader><header name="Content-Type" value="application/json"/></httpHeader>' as clob(10k) ccsid 1208),
                                  cast ('{
                                            	"INFINR": "3",
                                            	"INIDNR": "4",
                                            	"INNAM1": "Henry 8." ,
                                            	"INNAM2": "",
                                            	"INNAM3": "",
                                            	"INSTR":  "",
                                            	"INLAND": "",
                                            	"INPLZ":  "",
                                            	"INORT": "",
                                            	"INTEL": "",
                                            	"INFAX": "",
                                            	"INFTF": "",
                                            	"INEML": "",
                                            	"INBLZ": "",
                                            	"INKTO": "",
                                            	"ININTER": ""
                                         }' as clob(2g) ccsid 1208
                                       )
                                ), 
                  'lax $'               
                   COLUMNS (
                            VerarbeiteteZeilen CHAR(3) PATH 'lax $.SQLStateInfo.rowsAffectedCounts',
                            Fehler CHAR(100) PATH 'lax $.SQLStateInfo.SQLError',
                            Warnung CHAR(100) PATH 'lax $.SQLStateInfo.SQLWarnings'
                            )
                 ) as ServiceCall
;                 

select * from svklst00 where klfinr = 3


-----------------------------------------------------------------------
---- Service SQL_deleteCustomer aufrufen und Ergebnis (JSON) parsen

values(SYSTOOLS.HTTPDELETECLOB('http://172.16.111.23:10010/web/services/SQL_deleteCustomer/3/7',null));


select 
        * 
 from JSON_TABLE(SYSTOOLS.HTTPDELETECLOB('http://172.16.111.23:10010/web/services/SQL_deleteCustomer/3/1',null), 
                  'lax $'               
                   COLUMNS (
                            VerarbeiteteZeilen CHAR(3) PATH 'lax $.SQLStateInfo.rowsAffectedCounts',
                            Fehler CHAR(100) PATH 'lax $.SQLStateInfo.SQLError',
                            Warnung CHAR(100) PATH 'lax $.SQLStateInfo.SQLWarnings'
                            )
                 ) as ServiceCall
;


select * from svklst00 where klfinr = 3;

