**free

//---<CREATE_OBJECTS>--------------------------------------------------------------------------------------------------------------------------------
//
//    @compile{
//             CRTRPGMOD MODULE(&O/&N)
//                       SRCFILE(&L/&F)
//                       SRCMBR(&N)
//                       OPTION(*EVENTF)
//                       DBGVIEW(*SOURCE)
//                       REPLACE(*YES)
//           }
//
//
//    <! nur bei automatischer Binder-Source Generierung          !>
//    <! Befehl GENBNDSRC kann auch Stand-alone ausgefhrt werden !>
//
//    @generate{
//              GENBNDSRC SRCLIB(&L)
//                        SRCFILE(&F)
//                        SRCMBR(&N)
//                        PGMLVL(*CURRENT)
//                        SIG(EPOSGMBH_1.0.0.0)
//                         <! 1234567890123456 !>
//             }
//
//    @create{
//              CRTSRVPGM SRVPGM(&O/&N)
//                        MODULE(&O/&N)
//                        SRCFILE(QSRVSRC)
//                        ACTGRP(*CALLER)
//                        REPLACE(*YES)
//           }
//
//---</CREATE_OBJECTS>-------------------------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER
//
//  @purose  Erluternder Text
//
//
//
//  @author  Name
//
//  @version Versionsnummer - Datum
//
//  @param   Name Zweck
//
//
//
//---------------------------------------------------------------------------------------------------------------------------------------------------


ctl-opt nomain;

ctl-opt alwnull(*usrctl);
ctl-opt option(*nodebugio:*srcstmt:*nounref);

ctl-opt pgminfo(*pcml:*module:*dclcase:*V7);

/include QPOW3RSRC,CUSTOMER_H

dcl-f Customer00 usage(*output)
                 extdesc('SVKLST00')
                 extfile(*extdesc)
                 qualified
                 usropn;

dcl-f Customer01 keyed
                 usage(*input:*update:*delete)
                 extdesc('SVKLST01')
                 extfile(*extdesc)
                 qualified
                 usropn;



//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER_getSingleCustomer
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc CUSTOMER_getSingleCustomer export;
  dcl-pi *n int(10);
      inFirma like(lclCustomerBuffer.KLFINR) const;       // Request-Parameter
      inIdent  like(lclCustomerBuffer.KLIDNR) const;      //
      outCustomerBuffer likeds(tmplCustomerRec);          // Response-Parameter
      outStatus likeds(tmplStatus);                       //
  end-pi;

  dcl-ds lclCustomerBuffer likerec(Customer01.KLSTFMT01:*input) inz;
  dcl-ds lclCustomerKey likeds(tmplCustomerKey) inz;

  dcl-s retCode int(10) inz;

  monitor;
     open Customer01;
     lclCustomerKey.KLFINR = inFirma;
     lclCustomerKey.KLIDNR = inIdent;

     chain(n) %kds(lclCustomerKey) Customer01.KLSTFMT01 lclCustomerBuffer;
     if %found();
        eval-corr outCustomerBuffer = lclCustomerBuffer;
        outStatus.MsgId = 'MSG0001';
        outStatus.MsgText = 'Verarbeitung erfolgreich.';
     else;
        clear outCustomerBuffer;
        outStatus.MsgId = 'MSG0002';
        outStatus.MsgText = 'Kunde nicht gefunden.';
        retCode = 100;
     endif;

  on-error;
     retCode = -1;
  endmon;

  return retCode;

on-exit;
  close Customer01;
end-proc;


//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER_getManyCustomers
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc CUSTOMER_getManyCustomers export;
  dcl-pi *n int(10);
      inFirma like(lclCustomerBuffer.KLFINR) const;       // Request-Parameter
      inIdent  like(lclCustomerBuffer.KLIDNR) const;      //
      outCustomerArray_LENGTH int(10);
      outCustomerArray likeds(tmplCustomerRec) dim(10000);// Response-Parameter
      outStatus likeds(tmplStatus);                       //
  end-pi;


  dcl-ds lclCustomerArray likeds(tmplCustomerRec)dim(10000) inz;

  dcl-ds lclCustomerBuffer likerec(Customer01.KLSTFMT01:*input) inz;
  dcl-ds lclCustomerKey likeds(tmplCustomerKey) inz;
  dcl-s lclLoopIndex uns(10) inz;

  dcl-s retCode int(10) inz;

  monitor;
     open Customer01;
     lclCustomerKey.KLFINR = inFirma;
     lclCustomerKey.KLIDNR = inIdent;

     setll %kds(lclCustomerKey) Customer01.KLSTFMT01;
     read(n) Customer01.KLSTFMT01 lclCustomerBuffer;
     dow not %eof();
        lclLoopIndex += 1;
        if lclLoopIndex > 10000;
           leave;
        endif;
        lclCustomerArray(lclLoopIndex) = lclCustomerBuffer;
        read(n) Customer01.KLSTFMT01 lclCustomerBuffer;
     enddo;

     outCustomerArray_LENGTH = lclLoopIndex - 1;
     outCustomerArray = lclCustomerArray;

     if lclLoopIndex > 10000;
        outStatus.MsgId = 'MSG0003';
        outStatus.MsgText = 'Nicht alle Datenstze geladen.';
        retCode = 101;
     elseif lclLoopIndex > 0;
        outStatus.MsgId = 'MSG0001';
        outStatus.MsgText = 'Verarbeitung erfolgreich.';
     elseif lclLoopIndex = 0;
        clear outCustomerArray;
        outStatus.MsgId = 'MSG0002';
        outStatus.MsgText = 'Kunde nicht gefunden.';
        retCode = 100;
     endif;

  on-error;
     retCode = -1;
  endmon;

  return retCode;

on-exit;
  close Customer01;
end-proc;


//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER_insertCustomer
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc CUSTOMER_insertCustomer export;
  dcl-pi *n int(10);
      inCustomerBuffer likeds(tmplCustomerRec) const;
      outStatus likeds(tmplStatus);
  end-pi;

  dcl-ds lclCustomerBuffer likerec(Customer00.SVKLST00:*output) inz;
  dcl-s retCode int(10) inz;

  monitor;
     open Customer00;
     eval-corr lclCustomerBuffer = inCustomerBuffer;
     write Customer00.SVKLST00 lclCustomerBuffer;
     outStatus.MsgId = 'MSG0001';
     outStatus.MsgText = 'Verarbeitung erfolgreich.';
  on-error;
     outStatus.MsgId = 'ERR0001';
     outStatus.MsgText = 'Kunde nicht hinzugefgt.';
     retCode = -1;
  endmon;

  return retCode;

on-exit;
  close Customer00;
end-proc;


//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER_updateCustomer
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc CUSTOMER_updateCustomer export;
  dcl-pi *n int(10);
      inCustomerKey likeds(tmplCustomerKey) const;
      inCustomerBuffer likeds(tmplCustomerRec) const;
      outStatus likeds(tmplStatus);
  end-pi;

  dcl-ds lclCustomerBuffer likerec(Customer01.KLSTFMT01:*all) inz;
  dcl-s retCode int(10) inz;

  monitor;
     open Customer01;
     chain %kds(inCustomerKey) Customer01.KLSTFMT01 lclCustomerBuffer;
     eval-corr lclCustomerBuffer = inCustomerBuffer;
     update Customer01.KLSTFMT01 lclCustomerBuffer;
     outStatus.MsgId = 'MSG0001';
     outStatus.MsgText = 'Verarbeitung erfolgreich.';
  on-error;
     outStatus.MsgId = 'ERR0002';
     outStatus.MsgText = 'Kunde nicht aktualisiert.';
     retCode = -1;
  endmon;

  return retCode;

on-exit;
  close Customer01;
end-proc;



//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    CUSTOMER_deleteCustomer
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc CUSTOMER_deleteCustomer export;
  dcl-pi *n int(10);
      inCustomerKey likeds(tmplCustomerKey) const;
      outStatus likeds(tmplStatus);
  end-pi;

  dcl-ds lclCustomerBuffer likerec(Customer01.KLSTFMT01:*all) inz;
  dcl-s retCode int(10) inz;

  monitor;
     open Customer01;
     chain %kds(inCustomerKey) Customer01.KLSTFMT01 lclCustomerBuffer;
     delete Customer01.KLSTFMT01;
     outStatus.MsgId = 'MSG0001';
     outStatus.MsgText = 'Verarbeitung erfolgreich.';
  on-error;
     outStatus.MsgId = 'ERR0003';
     outStatus.MsgText = 'Kunde nicht gelscht.';
     retCode = -1;
  endmon;

  return retCode;

on-exit;
  close Customer01;
end-proc;


