**free

//---<CREATE_OBJECTS>--------------------------------------------------------------------------------------------------------------------------------
//
//    @compile{
//             CRTSQLRPGI OBJ(&O/&N)
//                        SRCFILE(&L/&F)
//                        SRCMBR(&N)
//                        OBJTYPE(*MODULE)
//                        OPTION(*EVENTF)
//                        REPLACE(*YES)
//                        RPGPPOPT(*LVL2)
//                        DBGVIEW(*SOURCE)
//           }
//
//    @create{
//             CRTPGM PGM(&O/&N)
//                    MODULE(&O/&N)
//                    BNDSRVPGM(
//                                 (*LIBL/HTTP)
//                             )
//                    ACTGRP(*NEW)
//            }
//
//---</CREATE_OBJECTS>-------------------------------------------------------------------------------------------------------------------------------





//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    WSCPW3R02
//
//  @purpose SOAP - Service Consumer
//
//  @author  Klaus-Peter Luttkus
//
//  @version 1.0.0 - 2020-05-06
//
//---------------------------------------------------------------------------------------------------------------------------------------------------



ctl-opt main(Main);

/if defined(*crtbndrpg)
   ctl-opt actgrp(*new);
/endif

ctl-opt alwnull(*usrctl);
ctl-opt option(*nodebugio:*srcstmt:*nounref);


/include QPOW3RSRC,HTTP_H
/include QPOW3RSRC,HTTP_C
/include QPOW3RSRC,HTTP_P

/include QPOW3RSRC,CUSTOMER_H


exec sql set option naming = *sys, commit = *CS, closqlcsr = *endactgrp;

dcl-proc Main;
  dcl-pi *n extpgm('WSCPW3R02');

  end-pi;

  dcl-s lclHandle like(tmplHandle);
  dcl-s lclRequest like(tmplHTTPBuffer) inz;
  dcl-s lclResponse like(tmplHTTPBuffer) inz;
  dcl-s lclURI like(tmplURI) inz('http://172.16.111.23:10116/web/services/SOAP_Customer_03Service/SOAP_Customer_03');
  dcl-s retCode ind inz(*on);

  monitor;

     setLogging(*on:'/tmp/axislog' + %char(%timestamp()) + '.log');
     if createTransport(lclURI:lclHandle);
        setHTTPMethod(lclHandle:POST);
        lclRequest = processParameters();
        sendRequest(lclHandle:lclRequest);
        getResponse(lclHandle:lclResponse);
        processResponse(lclResponse);
        destroyService(lclHandle);

        exec sql commit;
     endif;

  on-error;
     retCode = *off;
  endmon;

  return;

end-proc;


//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    processResponse
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc processResponse;
  dcl-pi *n ind;
      inSpoapResponse like(tmplHTTPBuffer) const;
  end-pi;

  dcl-s lclSoapResponse sqltype(xml_clob:65535) ccsid(*utf8);
  dcl-ds lclCustomerRec likeds(tmplCustomerRec) inz;
  dcl-s retCode ind inz(*on);

  monitor;
    lclSoapResponse_LEN = %len(%trim(inSpoapResponse));
    lclSoapResponse_Data = inSpoapResponse;

    exec sql
       declare SoapData cursor for
         select ws.*
           from xmltable('$soap/*:Envelope/*:Body/*:customer_getsinglecustomerResponse/*:return/*:outCustomerBuffer'
                             passing :lclSOAPResponse as "soap"
                    columns
                        name1 char(40)  path '*:KLNAM1',
                        name2 char(40)  path '*:KLNAM2',
                        name3 char(40)  path '*:KLNAM3',
                        strasse char(40)  path '*:KLSTR'

                        ) as WS;
       exec sql open SoapData;
       if SQLCODE = 0;
          exec sql fetch Soapdata into :lclCustomerRec.KLNAM1,
                                       :lclCustomerRec.KLNAM2,
                                       :lclCustomerRec.KLNAM3,
                                       :lclCustomerRec.KLSTR;
       endif;

  on-error;
     retCode = *off;
  endmon;

  return retCode;

end-proc;

//---------------------------------------------------------------------------------------------------------------------------------------------------
//
//  @name    processParameters
//
//---------------------------------------------------------------------------------------------------------------------------------------------------

dcl-proc processParameters;
  dcl-pi *n like(tmplHTTPBuffer);

  end-pi;

  dcl-s lclRequestCLOB sqltype(CLOB:65535);
  dcl-s retRequest like(tmplHTTPBuffer) inz;

  monitor;
     exec sql set :lclRequestCLOB = GET_CLOB_FROM_FILE('/XML/SingleCustomerTemplate.xml', 1);
     retRequest = LCLREQUESTCLOB_DATA;
     retRequest = %scanrpl('?1?':%char(1):lclRequest);
     retRequest = %scanrpl('?2?':%char(1000200):lclRequest);
  on-error;
     retRequest = '*ERROR';
  endmon;

  return retRequest;

on-exit;

end-proc;

